How to cache canvas shapes with Vue?
If you want to cache a node in a Vue app, you need to have access to the Konva node and use the node.cache() function.
To get access to a node you can use references and the component.getNode() method:
// in template:
<v-group ref="group">
// later in the code:
this.$refs.group.getNode().cache();
Instructions: Try to drag the whole stage. Then enable caching and try again. You should see much better performance with caching enabled.
<template>
<div>
<v-stage ref="stage" :config="stageConfig">
<v-layer ref="layer">
<v-group ref="group">
<v-star
v-for="item in list"
:key="item.id"
:config="{
x: item.x,
y: item.y,
rotation: item.rotation,
id: item.id,
numPoints: 5,
innerRadius: 30,
outerRadius: 50,
fill: '#89b717',
opacity: 0.8,
shadowColor: 'black',
shadowBlur: 10,
shadowOpacity: 0.6,
scaleX: item.scale,
scaleY: item.scale,
}"
/>
</v-group>
</v-layer>
</v-stage>
<div class="cache">
<input type="checkbox" @change="handleCacheChange"> cache shapes
</div>
</div>
</template>
<script>
const width = window.innerWidth;
const height = window.innerHeight;
export default {
data() {
return {
list: [],
dragItemId: null,
stageConfig: {
width: width,
height: height,
draggable: true
}
};
},
methods: {
handleCacheChange(e) {
const shouldCache = e.target.checked;
if (shouldCache) {
this.$refs.group.getNode().cache();
} else {
this.$refs.group.getNode().clearCache();
}
}
},
mounted() {
// Generate 300 random stars
for (let n = 0; n < 1000; n++) {
this.list.push({
id: Math.round(Math.random() * 10000).toString(),
x: Math.random() * width,
y: Math.random() * height,
rotation: Math.random() * 180,
scale: Math.random()
});
}
}
};
</script>
<style>
.cache {
position: absolute;
top: 0;
left: 0;
}
</style>

Skip to main content

Angular Konva Cache Tutorial

Caching rasterizes a node into an internal image, which can improve performance and is required for some effects such as filters.

This example accesses the underlying Konva node after render and calls cache() manually.

Instructions: The demo shows a rectangle with shadow styling that is cached after the view initializes.

For more details, see the Node API Reference and cache() documentation.

Cache Example

import { Component, ViewChild, AfterViewInit } from '@angular/core';
import { StageConfig } from 'konva/lib/Stage';
import { RectConfig } from 'konva/lib/shapes/Rect';

import {
  CoreShapeComponent,
  StageComponent,
} from 'ng2-konva';

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        <ko-rect #rect [config]="configRect"></ko-rect>
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class App implements AfterViewInit {
  @ViewChild('rect') rect!: any;

  public configStage: StageConfig = {
    width: window.innerWidth,
    height: window.innerHeight,
  };
  public configRect: RectConfig = {
    x: 50,
    y: 50,
    width: 100,
    height: 100,
    fill: 'red',
    shadowBlur: 10,
    shadowColor: 'black',
    shadowOffsetX: 5,
    shadowOffsetY: 5
  };

  ngAfterViewInit() {
    if (this.rect) {
      this.rect.getNode().cache();
    }
  }
}